import cv2
import cv2.cv as cv
#from PIL import Image
import numpy as np
#import matplotlib.pyplot as plt

def detection(image):
        path = "/Users/Sue/Desktop/CIS2/Detection/1/" # 1, 2, 3
        cam = "cam3/" #1, 2, 3, 4

	# import image
	frame_cv = image
	frame_np = np.array(frame_cv[:,:])

	# convert to YUV
	yuv_np = cv2.cvtColor(frame_np, cv.CV_BGR2YCrCb)
	yuv_cv = cv.fromarray(yuv_np)

	colors = ['red','yellow','green','blue']
	lowerb = [cv.Scalar(1,160,100), cv.Scalar(1,100,1), cv.Scalar(1,50,100), cv.Scalar(1,100,140)]
	upperb = [cv.Scalar(255,255,150), cv.Scalar(255,150,107), cv.Scalar(255,110,150), cv.Scalar(100,150,200)]
	centers = []

	for i in range(0,4):
                
		# threshold for color of interest
		color = 0
		color=cv.CreateImage(cv.GetSize(frame_cv), cv.IPL_DEPTH_8U, 1)
		cv.InRangeS(yuv_cv,lowerb[i],upperb[i], color)
	
		#save threshold FOR TEST
		color_np = 0
		color_np = np.array(color[:,:])
		cv2.imwrite(path+"Output/"+cam+colors[i]+'threshold.jpg',color_np)
	
		# get rid of noise
		cv.Erode(color,color,None,1)
		cv.Dilate(color,color,None,1)
		cv.Dilate(color,color,None,3)
		cv.Erode(color,color,None,3)
		color_np = np.array(color[:,:])
                cv2.imwrite(path+"Output/"+cam+colors[i]+'eroded.jpg',color_np)


		#choose maximum contour
		contours, hierarchy = cv2.findContours(color_np, cv2.RETR_LIST,cv2.CHAIN_APPROX_SIMPLE)
		max_area = 0
		for cnt in contours:
			area = cv2.contourArea(cnt)
			if area > max_area:
				max_area = area
				best_cnt = cnt
	
		if max_area > 0:
	
			#calculate contours
                        contour = 0
			contour = cv.CreateImage(cv.GetSize(frame_cv), cv.IPL_DEPTH_8U, 1)
			contour_np = np.array(contour[:,:])
			cv2.drawContours(contour_np,[best_cnt], cv.CV_FILLED, cv.Scalar(255,0,0))
			
			#save contour FOR TEST
			cv2.imwrite(path+"Output/"+cam+colors[i]+'contour.jpg',contour_np)
	
			#view images FOR TEST
			#cv2.imshow('original', frame_np)
			#cv2.imshow('threshold',color_np)
	
			#find centers
			M = cv2.moments(best_cnt)
			cx,cy = int(M['m10']/M['m00']), int(M['m01']/M['m00'])
			centers.append([cx, cy])
			#print([cx,cy])
			
			#save centers FOR TEST
			center = 0
			center = cv.CreateImage(cv.GetSize(frame_cv), cv.IPL_DEPTH_8U, 1)
			cv.Circle(center, (cx,cy),1, cv.Scalar(255,255,0))
			center_np = np.array(center[:,:])
			cv2.imwrite(path+"Output/"+cam+colors[i]+'center.jpg',center_np)
	
		else:
			centers.append(-1)
	

		# clean up
		cv2.destroyAllWindows()

	return centers


#main
path = "/Users/Sue/Desktop/CIS2/Detection/1/" # 1, 2, 3
cam = "cam3.bmp" #1, 2, 3, 4
image = cv.LoadImageM(path+cam)
centers = detection(image)
print(centers)
